/*!
 * @file laser.h
 * @brief a projectile, that is been shooted by a weapon
*/

#ifndef _LASER_H
#define _LASER_H

#include "projectile.h"

class Vector;
class Weapon;
class ParticleSystem;
class ParticleEmitter;
class FastFactory;

class Laser : public Projectile
{
  public:
    Laser ();
    virtual ~Laser ();


    virtual void activate();
    virtual void deactivate();

    virtual void collidesWith(WorldEntity* entity, const Vector& location);

    virtual void destroy ();

    virtual void tick (float time);
    virtual void draw ();


  private:
    static FastFactory*               fastFactory;

    static ParticleSystem*            explosionParticles;

    ParticleEmitter*                  emitter;


    WorldEntity* hitEntity; // FIXME TEMPORARY

};

#endif /* _LASER_H */
